#include <windows.h>
#include <stdio.h>
#include <vector>
#include <string>
#include "PEFile.h"


int wmain(int argc, wchar_t** argv)
{
  for(int i = 1; i < argc; i++)
  {
    PEFile                    pe_file(argv[i]);
    std::vector<const char*>  dll_names = pe_file.GetImportDllNames();

    printf("%S\n", argv[i]);
    for(size_t i = 0; i < dll_names.size(); i++)
    {
      printf("  %s\n", dll_names[i]);
      
      printf("    IAT RVA  HINT NAME\n");
      std::vector<ImportSymbol>
        import_symbols = pe_file.GetImportSymbols(dll_names[i]);
      for(size_t j = 0; j < import_symbols.size(); j++)
      {
        printf("    %08X ", import_symbols[j].iat_entry_rva);
        if( import_symbols[j].import_by_name )
          printf("%04d %s\n", import_symbols[j].hint, import_symbols[j].name);
        else
          printf("Ordinal %d\n", import_symbols[j].ordinal);
      }
      printf("\n");
    }
  }

  return 0;
}

